
/* main (int argc, char **argv)
{
	double  matrice[10][3];
	
	matrice[2][2]=1.; /*gestito in modo sequenziale,fa scorre prima il secondo indice e poi il primo, per questo è necessario che conosca dimensioni della matrice*/
	
	
/* usiamo strutture(zona di memoria in cui son definiti piu campi) per cercare di avere una maggiore dinamicità*/	

#include<stdio.h>
#include<stdlib.h> 

struct mat {

				int r;    /* le righe e le colonne*/
				int c;
				double *a;
				};

/* per richiamare campi di una struttura, se definisco una struttura:

	struct mat m;
	m.c=10;
	
	se definisco invece un puntatore a struttura:
	
	struct mat *m;
	(*m).c=10    oppure  m->c=10  */

/*adesso mi serve una funzione che mi riempa la matrice*/
struct mat *newm (int r, int c) /* la funzione rende un puntatore alla struttura che ho creato*/
{
	struct mat *m; /* definisco *m come puntatore a una struttura di tipo mat*/
	m=calloc(1,sizeof (struct mat));/* calloc restituisce l'indirizzo della zona che ha liberato*/
	m->r=r;
	m->c=c;
	/* ora devo liberare spazio per gli elementi*/
	m->a=calloc(r*c,sizeof(double)); /* cosi definisco una matrice tutta a zero*/
	return m;	
}

/* ok ora dobbiamo infilarci dentro i dati*/
struct mat *input_mat()
{
	int r,c,j;
	struct mat *m;
	printf("inserisci numero righe e colonne\n");
	scanf("%d%d", &r,&c); /* restituisce numero dati che è riuscita a leggere correttamente con il campo che ho dichiarato*/
	m=newm(r,c);
	for (j=0;j<r*c;j++)
		{
			scanf("%lg",&(m->a[j]));
					
		}		
		
	return m;
}


void printm(struct mat*m)
{
	int i,j;
	for(i=0;i<m->r;i++)
		{
			for (j=0;j<m->c;j++)
				{
					printf("%lg\t",m->a[i*m->c+j]); /* /t è la tabulazione... molto figa!*/
				}
			printf("\n");
		}
}


main (int argc, char **argv)
{
	printm(input_mat());
}



/* provare a fare prodotto per matrici, inversa, una fettina di culo...*/



