#include <stdio.h>
#include <stdlib.h>

typedef struct{
  int n; /*numero righe*/
  int m; /*numero colonne*/
  double *a; /*puntatore alla memoria che contien mn numeri*/
} mat;

mat *newmat(int n,int m)
{
  mat *c;
  c=(mat *)calloc(1,sizeof(mat));
  c->n=n;
  c->m=m;
  c->a=(double *)calloc(m*n,sizeof(double));
  return c;			
}

mat *readmat(int n, int m, double *v)
{
  int j;
  mat *r;
  r=newmat(n,m);
  for(j=0;j<m*n;j++) r->a[j]=v[j]; /*oppure *((r->a)+j)=... */
  return r;
}

void printmat(mat *addr)
{
  int j,k,n,m;
  n=addr->n;
  m=addr->m;
  for(j=0;j<n;j++){
    for(k=0;k<m;k++) printf("%8lg ", addr->a[j*m+k]);
    printf("\n");
  }
}

main(int argc, char **argv)
{
  int righe, colonne,j;
  double *v;
  scanf("%d%d", &righe, &colonne);
  v=calloc(righe*colonne,sizeof(double));
  for(j=0;j<righe*colonne;j++) scanf("%lgx", &v[j]);
  printmat(readmat(righe,colonne,v));
}
